//	by EvilJess aka Jeffrey Bakker 2003

//	New or modified code (C)2003, 2004 Jeffrey Bakker <evil@damnclan.com>
//	Existing code for Unreal  Tournament 2004 Copyright  2004 Epic Games, Inc.


//	Certain Death - InstaSkel Rifle
//	Copyright (C) 2004 Jeffrey Bakker

//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Lesser General Public
//	License as published by the Free Software Foundation; either
//	version 2.1 of the License, or (at your option) any later version.

//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Lesser General Public License for more details.

//	You should have received a copy of the GNU Lesser General Public
//	License along with this library; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

class DeathFire extends SuperShockBeamFire;

var class<DamageType> DamageTypeHead;

function bool AllowMultiHit()
{
	return true;
}

function TracePart(Vector Start, Vector End, Vector X, Rotator Dir, Pawn Ignored)
{
	local Vector HitLocation, HitNormal;
	local Actor Other;
	local float dist;

	Other = Ignored.Trace(HitLocation, HitNormal, End, Start, true);

	if ( (Other != None) && (Other != Ignored) )
	{
		if ( !Other.bWorldGeometry )
		{

			if(	(Pawn(Other) != None) &&
				(Other.GetClosestBone(HitLocation,X,dist,'head',10) == 'head')	)
			{
				//Pawn(Other).Died(Instigator.Controller, DamageTypeHead, Location);
				Other.TakeDamage(DamageMax, Instigator, HitLocation, 1*X, DamageTypeHead);
			} else	Other.TakeDamage(DamageMax, Instigator, HitLocation, Momentum*X, DamageType);

			HitNormal = Vect(0,0,0);
			if ( (Pawn(Other) != None) && (HitLocation != Start) && AllowMultiHit() )
				TracePart(HitLocation,End,X,Dir,Pawn(Other));
		}
	}
	else
	{
		HitLocation = End;
 		HitNormal = Vect(0,0,0);
	}
	SpawnBeamEffect(Start, Dir, HitLocation, HitNormal, 0);
}

function SpawnBeamEffect(Vector Start, Rotator Dir, Vector HitLocation, Vector HitNormal, int ReflectNum)
{
	local ShockBeamEffect Beam;
    
	if ( (Instigator.PlayerReplicationInfo.Team != None) && (Instigator.PlayerReplicationInfo.Team.TeamIndex == 1) )
		Beam = Spawn(class'BlueSuperShockBeam',,, Start, Dir);
	else
		Beam = Spawn(BeamEffectClass,,, Start, Dir);
	if (ReflectNum != 0) Beam.Instigator = None; // prevents client side repositioning of beam start
	Beam.AimAt(HitLocation, HitNormal);
}

function StartBerserk()
{
	DamageType = class'CertainDeath2.DamTypeDeathStorm';

	FireRate = 0.123456;
	Momentum = 16700.000000;

	DamageMin = 66;
	DamageMax = 66;
}

function StopBerserk()
{
	DamageType = default.DamageType;

	FireRate = default.FireRate;
	Momentum = default.Momentum;

	DamageMin = default.DamageMin;
	DamageMax = default.DamageMax;
}

defaultproperties
{
	BeamEffectClass=Class'CertainDeath2.DeathBeamEffect'
	DamageType=Class'CertainDeath2.DamTypeInstaSkel'
	DamageTypeHead=Class'CertainDeath2.DamTypeExplode'
	DamageMin=666
     	Momentum=100000.000000
	FireSound=Sound'WeaponSounds.BaseGunTech.BLockOn1'
	FireRate=0.970000
	AmmoClass=Class'CertainDeath2.DeathAmmo'
	AmmoPerFire=0
}