//	by EvilJess aka Jeffrey Bakker 2003

//	New or modified code (C)2003, 2004 Jeffrey Bakker <evil@damnclan.com>
//	Existing code for Unreal  Tournament 2004 Copyright  2004 Epic Games, Inc.


//	Certain Death - InstaSkel Rifle
//	Copyright (C) 2004 Jeffrey Bakker

//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Lesser General Public
//	License as published by the Free Software Foundation; either
//	version 2.1 of the License, or (at your option) any later version.

//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Lesser General Public License for more details.

//	You should have received a copy of the GNU Lesser General Public
//	License along with this library; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

class EvilInstaGib extends ZoomSuperShockRifle;

#exec TEXTURE IMPORT NAME=Scope FILE=Textures\scope.pcx GROUP=Skins
#exec TEXTURE IMPORT NAME=GridOverlay FILE=Textures\grid.pcx GROUP=Skins
#exec TEXTURE IMPORT NAME=GridTex FILE=Textures\SniperTex0.pcx GROUP="Skins" FLAGS=2 LODSET=LODSET_WeaponSkin

var() bool bZooming;
var transient float LastFOV;


simulated event RenderOverlays( Canvas Canvas )
{
	local PlayerController PCtrl;
	local float Scale;

	PCtrl = PlayerController(Instigator.Controller);

	if ( LastFOV > PCtrl.DesiredFOV ) {
		PlaySound(Sound'WeaponSounds.LightningGun.LightningZoomIn', SLOT_Misc,,,,,false);
   	}
    	else
	if ( LastFOV < PlayerController(Instigator.Controller).DesiredFOV ) {
		PlaySound(Sound'WeaponSounds.LightningGun.LightningZoomOut', SLOT_Misc,,,,,false);
	}

	LastFOV = PCtrl.DesiredFOV;

	if ( PCtrl.DesiredFOV == PCtrl.DefaultFOV) {

		Super.RenderOverlays(Canvas);

		bZooming = false;

		PCtrl.MyHud.bCrosshairShow = True;
		PCtrl.MyHud.bShowWeaponInfo = True;
		PCtrl.MyHud.bShowPersonalInfo = True;
		PCtrl.MyHud.bShowPoints = True;
		PCtrl.MyHud.bShowWeaponBar = False;

	} else {
		SetZoomBlendColor(Canvas);

		PCtrl.MyHud.bCrosshairShow = False;
		PCtrl.MyHud.bShowWeaponInfo = False;
		PCtrl.MyHud.bShowPersonalInfo = False;
		PCtrl.MyHud.bShowPoints = False;
		PCtrl.MyHud.bShowWeaponBar = False;

		Scale = Canvas.ClipX/640 * 1.0; //1.5
		Canvas.SetPos(0.5 * Canvas.ClipX - 128 * Scale, 0.5 * Canvas.ClipY - 128 * Scale );
        	Canvas.Style = ERenderStyle.STY_Translucent;
		Canvas.DrawIcon(Texture'Scope', Scale);
		Canvas.SetPos(0.5 * Canvas.ClipX + 64 * Scale, 0.5 * Canvas.ClipY + 96 * Scale);
		Canvas.DrawColor.R = 168;
		Canvas.DrawColor.G = 0;
		Canvas.DrawColor.B = 0;
		Scale = PCtrl.DefaultFOV/PCtrl.DesiredFOV;

		Canvas.Font = PCtrl.MyHud.LargerFontThan(Canvas.Font);
		Canvas.bNoSmooth = false;
//		Canvas.DrawText("x"$scale);

		Canvas.SetPos(0,0);
		Canvas.DrawTile( Material'GridOverlay', Canvas.SizeX, Canvas.SizeY, 0.0, 0.0, 512, 512 );

		Canvas.SetPos(0.5 * Canvas.ClipX + 98 * Scale, 0.5 * Canvas.ClipY + 130 * Scale);
		Canvas.DrawText(""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2));
		Canvas.SetPos(0.5 * Canvas.ClipX + 90 * Scale, 0.5 * Canvas.ClipY + 118 * Scale);
		Canvas.DrawText(""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2)$""$Rand(2));

		Canvas.SetPos(12,120);
		Canvas.DrawText("by EvilJess");
		Canvas.SetPos(12,140);
		Canvas.DrawText("Zoom Activated");
		Canvas.SetPos(12,160);
		Canvas.DrawText(scale$"x Zoom Precision");


		Canvas.DrawColor.R = 64;
		Canvas.SetPos(15,64);
		Canvas.Font = PCtrl.MyHud.LargerFontThan(Canvas.Font);
		Canvas.DrawText(ItemName);

		Canvas.DrawColor.R = 128;
		Canvas.SetPos(12,62);
		Canvas.DrawText(ItemName);

		bZooming = true;
	}
}

defaultproperties
{
	ItemName="Certain Death InstaSkel Rifle"
	Description="The Certain Death rifle skeletizes its victims instantly. It has a customized zoom, can do headshots, and has a very drastic and annihilating effect in berserk mode.|By EvilJess aka Jeffrey Bakker|http://evil.damnclan.com"

	AttachmentClass=Class'CertainDeath2.EvilInstaGibAttachment'
	FireModeClass(0)=class'CertainDeath2.DeathFire'

	Skins(0)=Texture'CertainDeath2.Skins.GridTex'
//	Skins(1)=Texture'CertainDeath2.Skins.GridTex'
	Style=STY_Translucent
}
